module fstat

use glob_var

implicit none

contains

subroutine f_stat

integer::i,j,k,l,m,mm,o,p,sub1
integer,allocatable::ii(:),jj(:),nn(:),breed1(:)
real::si,self,fx,fi,d,fmet
real,allocatable::sii(:),dij(:,:),fii(:,:),lossfii(:)
real,allocatable::lossD(:),gl(:),gt(:),fst(:,:),wsd(:),bsd(:),Gi(:)

!open(4,file='result.lst')
open(2,file='results.lst',status='old',position='append')

sub1=0
do i=1,sub
  if(breed(i).ne.0)sub1=sub1+1
end do

allocate(breed1(sub1))

j=0
do i=1,sub  
   if(breed(i).eq.0)cycle
   j=j+1
   breed1(j)=breed(i)
end do


!-------------------------------------------------
allocate(nn(sub1))
nn=0

do i=1,sub1
 do j=1,n
  if(plem(j).eq.breed1(i) .and. stat(j).eq.1)nn(i)=nn(i)+1
 end do
end do

allocate(ii(n))

nn=0

do i=1,sub1
  do j=1,n
   if(plem(j).eq.breed1(i) .and. stat(j).eq.1)then
        nn(i)=nn(i)+1
        ii(sum(nn(1:i-1))+nn(i))=aid(j)
   end if
  end do
end do


!------------------------------------------

allocate(sii(sub1),fii(sub1,sub1),dij(sub1,sub1),fst(sub1,sub1), &
         wsd(sub1),bsd(sub1),Gi(sub1))

sii=0

do i=1,sub1
  do j=1,nn(i)
   sii(i)=sii(i)+A(row(ii(sum(nn(1:i-1))+j)))
  end do
end do

do i=1,sub1
 sii(i)=sii(i)/(2*nn(i))
end do


si=0
do i=1,sub1
  si=si+(sii(i)*nn(i))
end do
self=si/sum(nn)
write(2,*)'self co-ancestry',self
print*,'self co-ancestry',self

fx=0
do i=1,sub1
   fx=fx+((2*sii(i)-1)*nn(i))
end do

fx=fx/sum(nn)

print*,'inbreeding',fx
write(2,*)'inbreeding',fx

mm=0
fii=0

do i=1,sub1
  do j=1,sub1
     do o=1,nn(i)
       do p=1,nn(j)
         k=min(ii(sum(nn(1:i-1))+o),ii(sum(nn(1:j-1))+p))
         l=max(ii(sum(nn(1:i-1))+o),ii(sum(nn(1:j-1))+p))
         mm=row(k)+(l-k)
         fii(i,j)=fii(i,j)+A(mm)
       end do
     end do
     fii(i,j)=fii(i,j)/(2*nn(i)*nn(j))
  end do
end do


fi=0
do i=1,sub1
   fi=fi+(fii(i,i)*nn(i))
end do

fi=fi/sum(nn)

print*,'Mean co-ancestry',fi
write(2,*)'Mean co-ancestry',fi

dij=0
m=0

do i=1,sub1
  do j=1,sub1!i+1
    dij(i,j)=((fii(i,i)+fii(j,j))/2)-fii(i,j)
  end do
end do


d=0
m=0

do i=1,sub1
  do j=i+1,sub1
    d=d+(dij(i,j)*nn(i)*nn(j))
  end do
end do

d=2*d/sum(nn)**2

print*,'Nei Avg. D',d
write(2,*)'Nei Avg. D',d

fmet=0
m=0

do i=1,sub1
  do j=1,sub1
    fmet=fmet+(fii(i,j)*nn(i)*nn(j))
  end do
end do

fmet=fmet/sum(nn)**2

print*,'Mean meta co-ancestry',fmet
print*,'----------------------------'
write(2,*)'Mean meta co-ancestry',fmet

print*,'FIS',(fx-fi)/(1-fi)
print*,'FST',d/(1-fmet)
print*,'FIT',(fx-fmet)/(1-fmet)
write(2,*)'----------------------------'
write(2,*)'FIS',(fx-fi)/(1-fi)
write(2,*)'FST',d/(1-fmet)
write(2,*)'FIT',(fx-fmet)/(1-fmet)
write(2,*)'----------------------------'
write(2,*)'GD_T',(1-fmet)
write(2,*)'GD_WI',(1-self)
write(2,*)'GD_WS',(1-fi)
write(2,*)'GD_BI',(self-fi)
write(2,*)'GD_BS',(fi-fmet)
write(2,*)'----------------------------'
write(2,*)'.........fij................'
do i=1,sub1
     write(2,*)fii(i,:)
end do

write(2,*)'----------------------------'
write(2,*)'.........Nei distanc..........'
do i=1,sub1
  write(2,*)dij(i,:)
end do

fst=0
do i=1,sub1
  fst(i,i)=((2*sii(i)-1)-fii(i,i))/(1-fii(i,i))
end do

do i=1,sub1
   do j=i+1,sub1
     fst(i,j)=((dij(i,j)*nn(i)*nn(j))*2)/((nn(i)+nn(j))**2)
     fst(i,j)=fst(i,j)/(1-((fii(i,i)*nn(i)**2)+((fii(i,j)*nn(i)*nn(j))*2)+(fii(j,j)*nn(j)**2))&
             /((nn(i)+nn(j))**2))
   end do
end do

!Gi=0

!do i=1,sub1
!  Gi(i)=(sii(i)-fii(i,i))/(1-fii(i,i))
!end do

write(2,*)'----------------------------'
write(2,*)'.........Gi.................'
!write(4,*)Gi
do i=1,sub1
  write(2,*)(sii(i)-fii(i,i))/(1-fii(i,i))
end do




write(2,*)'----------------------------'
write(2,*)'.........FISs/FSTs..........'
do i=1,sub1
  write(2,*)fst(i,:)
end do

wsd=0

do i=1,sub1
   wsd(i)=(fii(i,i)*nn(i))/sum(nn)
end do

bsd=0

do i=1,sub1
   do j=1,sub1
      bsd(i)=bsd(i)+(dij(i,j)*nn(i)*nn(j))
   end do
   bsd(i)=bsd(i)/(sum(nn)**2)
end do

write(2,*)'----------------------------------------------------------'
write(2,*)'     wsd     -          bsd    =     prop.contrib.     '
write(2,*)'----------------------------------------------------------'

do i=1,sub1
   write(2,*)wsd(i),bsd(i),wsd(i)-bsd(i)
end do

allocate(lossfii(sub1),lossD(sub1),gl(sub1),gt(sub1))

lossfii=0

do i=1,sub1
  do j=1,sub1
    if(j.eq.i)cycle
    lossfii(i)=lossfii(i)+fii(j,j)*(real(nn(j))/(sum(nn)-nn(i)))
  end do
  lossfii(i)=fi-lossfii(i)
  lossfii(i)=lossfii(i)/(1-fmet)
end do


!write(4,*)lossfii

lossD=0

do i=1,sub1
   do j=1,sub1
   if(j.eq.i)cycle
      do o=j,sub1
      if(o.eq.i)cycle
         lossD(i)=lossD(i)+((dij(j,o)*real(nn(j))*nn(o))*2.0)
      end do
   end do
   lossD(i)=lossD(i)/((sum(nn)-nn(i))**2)
   lossD(i)=d-lossD(i)
   lossD(i)=lossD(i)/(1-fmet)
end do


gl=lossfii-lossD


gt=0

do i=1,sub1
  do j=1,sub1
  if(j.eq.i)cycle
     do o=1,sub1
     if(o.eq.i)cycle
       gt(i)=gt(i)+(fii(j,o)*real(nn(j))*real(nn(o)))
     end do
  end do
  gt(i)=gt(i)/((sum(nn)-nn(i))**2)
  gt(i)=1-gt(i)
end do


write(2,*)'----------------------------------------------------------'
write(2,*)'     GT      |         fii   -      D     =        gl     '
write(2,*)'----------------------------------------------------------'
do i=1,sub1
   write(2,*)gt(i),lossfii(i),lossD(i),gl(i)
end do


close(2)

end subroutine f_stat

end module fstat
