module  genint

use glob_var

implicit none

contains

subroutine gen_int

integer::i,j,ip,im,x,xx,kk,num,isex
integer,allocatable::nanc(:),stat1(:)
real,allocatable::eff(:,:),ing(:,:)


!--------------------------------------
allocate(stat1(n))

do xx=1,sub
 if(breed(xx).ne.0)then
    do i=1,n
       if(plem(i).eq.breed(xx) .and. stat(i).eq.1)then
          stat1(i)=1
       else
          stat1(i)=0
       end if
    end do
 else
     stat1=stat
 end if



!----------------------------------- 
!.....Pocty jedincu na rodice.....
!num=sum(stat(:))

 allocate(nanc(n))

 nanc=0

 do i=1,n
   if (sid(i).ne.0) then
       nanc(i)=nanc(i)+1
   end if
   if (did(i).ne.0) then
     nanc(i)=nanc(i)+1
   end if
 end do


 allocate(eff(2,2),ing(2,2))

 eff=0.
 ing=0.

 !open(2,file='genin2.out')

 do i=1,n
    if(stat1(i).eq.1) then
      isex=sex(i)
      x=0
      if(rok(sid(i)).gt.0 .and.stat(i).eq.1) then
          x=dfloat(rok(i)-rok(sid(i)))
          write(2,*)'sid',x
          if(x.gt.0) then
             eff(1,isex)=eff(1,isex)+1
             ing(1,isex)=ing(1,isex)+x
          end if 
      end if
   
      if(rok(did(i)).gt.0 .and.stat(i).eq.1) then
          x=dfloat(rok(i)-rok(did(i)))
          write(2,*)'did',x
          if(x.gt.0) then
            eff(2,isex)=eff(2,isex)+1
            ing(2,isex)=ing(2,isex)+x
          end if
      end if
   end if
 end do

!open(2,file='genin2.out')
!do i=1,n
!   write(2,*)i,eff(i,2),ing(i,2),'|',eff(i,2),ing(i,2)
!end do

 do i=1,2
   do j=1,2
     x=eff(i,j)
     if(x.gt.0) ing(i,j)=ing(i,j)/x
   end do
 end do

 open(2,file='results.lst',status='old',position='append')
 write(2,*)'------------------------------------'
 write(2,*)'Population: ',breed(xx)
 write(2,*)' '

 write(2,*)'sir-son       = ',ing(1,1),eff(1,1)
 write(2,*)'sir-daughter  = ',ing(1,2),eff(1,2)
 write(2,*)'dam-son       = ',ing(2,1),eff(2,1)
 write(2,*)'dam-daughter  = ',ing(2,2),eff(2,2)
 write(2,*)'overall       = ',(ing(1,1)+ing(1,2)+ing(2,1)+ing(2,2))/4

end do

 close(2)

end subroutine

end module genint








