module porg

use glob_var

implicit none

contains

subroutine p_org 

integer::ha,i,j,ii,ip,im,k,l,ll,mm,nn,npop,nfond,indi(2000)  !.......Zde.........(1000)
integer::nr,xx,o,p
integer,allocatable::stat1(:),ngen(:),ndes(:),sid1(:),did1(:),year(:),iii(:)
real::pod
real(8)::fii,eps,z,cum,sum,x,y,r,xmax,xmin
real(8),allocatable::prob(:),aj(:)!,ndes(:)!,ngen(:)

!----------------------------------
open(2,file='results.lst',status='old',position='append')
open(3,file='result1.lst')
open(5,file='GD_loss.txt')
open(8,file='aver_Fx.txt')

!----------------------------------

!***************************************************
!  Nutno pridat sloupecky sid1 a did1
!****************************************************


allocate(stat1(n),prob(n),aj(n),ndes(n),ngen(n),sid1(n),did1(n))

sid1=sid
did1=did

do xx=1,sub
! print*,'Populace: ',xx
 write(2,*)'Population: ',breed(xx)
 write(2,*)' '
! print*,'10'
 if(breed(xx).ne.0)then
    do i=1,n
       if(plem(i).eq.breed(xx) .and. stat(i).eq.1)then
          stat1(i)=1
       else
          stat1(i)=0
       end if
    end do
 else
     stat1=stat
 end if
 !----------------------------------

 sid=sid1; did=did1
 
 eps=0.00000001d0
 k=0
 npop=0
 prob=0
 ndes=0

!print*,'50'

 do i=1,n
   if(sid(i).lt.0) sid(i)=0
   if(did(i).lt.0) did(i)=0
 end do

 do i=1,n
   if(sid(i).ne.0) ndes(sid(i))=ndes(sid(i))+1
   if(did(i).ne.0) ndes(did(i))=ndes(did(i))+1
 end do

 do i=1,n
   if(ndes(i).eq.0) k=k+1
 end do

 ngen=gen-1
 do i=1,n
    if(stat1(i).eq.1) then
       prob(i)=1.d0
       npop=npop+1
    end if
 end do

 do k=n,1,-1
   i=aid(k)
   if(stat1(i).eq.1) then
      ip=sid(i)
      im=did(i)
      if(ip.ne.0) prob(ip)=prob(ip)+prob(i)*0.5d0
      if(im.ne.0) prob(im)=prob(im)+prob(i)*0.5d0
    end if
 end do
 
 do k=n,1,-1
   i=aid(k)
   if(stat1(i).ne.1) then
      ip=sid(i)
      im=did(i)
      if(ip.ne.0) prob(ip)=prob(ip)+prob(i)*0.5d0
      if(im.ne.0) prob(im)=prob(im)+prob(i)*0.5d0
   end if
 end do

 x=0.d0
 y=0.d0
 nfond=0
 do i=1,n
    if(sid(i).eq.0 .and. did(i).eq.0 .and. stat1(i).ne.1.and.prob(i).gt.0.d0) then
       nfond=nfond+1
       y=prob(i)/dfloat(npop)
       x=x+y*y
    else if((sid(i).eq.0 .or. did(i).eq.0) .and. stat1(i).ne.1 .and. &
 prob(i).gt.0.d0) then
      y=prob(i)*0.5d0/dfloat(npop)
      x=x+y*y
      nfond=nfond+1
   end if
 end do

 x=1.d0/x

 !open(3,file='result1.lst')

 write(2,'(" Number of founders          : ",i7)')nfond
 write(2,'(" Effective number of founders: ",f10.2)')x
 write(2,*)' '
 
 


 !---------Zde dat podminku, ale asi k nicemu-------
 !open(2,file='result1.out')
 !do i=1,n
 !   if(prob(i).gt.0.d0 .and. stat1(i).ne.1) then
 !      z=prob(i)/dfloat(npop)
 !      if(sid(i).eq.0 .and. did(i).eq.0) then
 !        y=z
 !      else if(sid(i).eq.0 .or. did(i).eq.0) then
 !         y=0.5d0*z
 !      else
 !         y=0.d0
 !      end if
 !      write(4,'(i10,2f10.6)'),i,y,z
 !   end if
 !end do
 !--------------------------------------------------
 
 cum=0.d0
 sum=0.d0

 l=0
 
 print*,'154'
 write(3,*)'======================================================================'
 write(3,*)'  Population:',breed(xx)
 write(3,*)'----------------------------------------------------------------------'
 write(3,*)'  #      ID   cont.   cum.cont.      no.descendent       min       max'
 write(3,*)'======================================================================'

 print*,'161'
 pod=1
 !do while (l.lt.60 .and. cum.lt.1.d0-eps)  !....Zde,,,,,(50)
 do while (l.lt.1000 .and. cum.lt.1.d0-eps .and. pod.gt.0.0009d0)
 
   l=l+1

    x=0.d0
    do i=1,l-1
       prob(indi(i))=0.d0
    end do
 
    do i=1,n
       if(x.lt.prob(i) .and. stat1(i).ne.1) then
         j=i
         x=prob(i)
       end if
    end do
 
    x=prob(j)/dfloat(npop)
    y=prob(j)/dfloat(npop)
    cum=cum+y
    sum=sum+y*y
    indi(l)=j
    r=y
 
    if(r.gt.0.d0) then
      nr=int((1.d0-cum)/r)
      z=1.d0-cum-dfloat(nr)*r
    else
      nr=0
      z=0.d0
    end if
 
    xmin=1.d0/(sum+dfloat(nr)*r*r+z*z)
    nr=nfond-l
    if(nr.gt.0) then
      r=(1.d0-cum)/dfloat(nr)
    else
      r=0.d0
    end if
 
    xmax=1.d0/(sum+dfloat(nr)*r*r)
 
    write(3,'(i4,i8,f8.4,f12.4,13x,i6,2f10.4)')l,j,x,cum,ndes(j),xmin,xmax
 
    sid(j)=0
    did(j)=0

    do i=1,n
       if(stat1(i).eq.1) then
         prob(i)=1.d0
       else
         prob(i)=0.d0
       end if
    end do

    do k=n,1,-1
      i=aid(k)
      if(stat1(i).eq.1) then
        ip=sid(i)
        im=did(i)
        if(ip.ne.0) prob(ip)=prob(ip)+prob(i)*0.5d0
        if(im.ne.0) prob(im)=prob(im)+prob(i)*0.5d0
      end if
    end do

    do k=n,1,-1
      i=aid(k)
      if(stat1(i).ne.1) then
        ip=sid(i)
        im=did(i)
        if(ip.ne.0) prob(ip)=prob(ip)+prob(i)*0.5d0
        if(im.ne.0) prob(im)=prob(im)+prob(i)*0.5d0
      end if
    end do

    do i=1,n
      aj(i)=0.d0
    end do

    do i=1,l
      ii=indi(i)
      aj(ii)=1.d0
    end do


    do k=1,n
      i=aid(k)
      ip=sid(i)
      if(ip.ne.0 .and. aj(ip).ne.0.d0) aj(i)=aj(i)+0.5d0*aj(ip)
      im=did(i)
      if(im.ne.0 .and. aj(im).ne.0.d0) aj(i)=aj(i)+0.5d0*aj(im)
    end do
 
    do i=1,n
      prob(i)=prob(i)*(1.d0-aj(i))
    end do
 pod=xmax-xmin
 end do
 
! write(3,*)' '
 !pod=xmax-xmin
! print*,pod
 write(2,'("Lower Bound :",f10.2)')xmin
 write(2,'("Upper Bound :",f10.2)')xmax
!print*,'porg 264'
end do

close(3)
close(4)



!-----------Pokus o ztratu GD------------------
ll=maxval(rok)
allocate(year(ll))


!open(14,file='GD_loss.txt')

!year=0

!do i=1,n
! if(rok(i).NE.0 .AND. plem(i).eq.breed(xx) then
!   year(rok(i))=year(rok(i))+1
! end if
!end do

!stat1=0

do xx=1,sub
! print*,'Populace: ',xx
 write(5,*)'-------------------------------------------------------------------'
 write(5,*)'Population: ',breed(xx)
 write(5,*)'-------------------------------------------------------------------'
 write(5,*)'         |         Loss of Genetic diversity base on'
 write(5,*)'    year |  uneq.f.contribution  |  gen.drift |             total  '
 write(5,*)'-------------------------------------------------------------------'

! write(5,*)' '
! print*,'10'

 write(8,*)'--------------------------------------------------'
 write(8,*)'           Average inbreeding per year            '
 write(8,*)'--------------------------------------------------'
 write(8,*)'year|   avg. Fx  | No. of animals in year      '
 write(8,*)'--------------------------------------------------'
 


 year=0
 
 do i=1,n
  if(rok(i).NE.0 .AND. plem(i).eq.breed(xx)) then
    year(rok(i))=year(rok(i))+1
  end if
 end do


 do ha=ll,1,-1
 ! stat1=0
  if(year(ha).EQ.0)cycle

   prob=0
   aj=0
   ndes=0
   ngen=0
   stat1=0
       if(breed(xx).ne.0) then
           do i=1,n
              if(plem(i).eq.breed(xx) .and. rok(i).eq.ha)then
                 stat1(i)=1
              else
                  stat1(i)=0
              end if
           end do
       end if
       if(breed(xx).eq.0) then
          do i=1,n
           if(rok(i).eq.ha)then
              stat1=1
           else
              stat1=0
           end if   
          end do           
       end if
       

!print*,'319',ha

    

       eps=0.00000001d0
       k=0
       npop=0
       prob=0
       ndes=0

        do i=1,n
          if(sid(i).lt.0) sid(i)=0
          if(did(i).lt.0) did(i)=0
        end do

        do i=1,n
          if(sid(i).ne.0) ndes(sid(i))=ndes(sid(i))+1
          if(did(i).ne.0) ndes(did(i))=ndes(did(i))+1
        end do

        do i=1,n
           if(ndes(i).eq.0) k=k+1
        end do

        ngen=gen-1
        do i=1,n
           if(stat1(i).eq.1) then
            prob(i)=1.d0
            npop=npop+1
           end if
        end do

    do k=n,1,-1
      i=aid(k)
      if(stat1(i).eq.1) then
        ip=sid(i)
        im=did(i)
        if(ip.ne.0) prob(ip)=prob(ip)+prob(i)*0.5d0
        if(im.ne.0) prob(im)=prob(im)+prob(i)*0.5d0
      end if
    end do


   do k=n,1,-1
      i=aid(k)
      if(stat1(i).ne.1) then
         ip=sid(i)
         im=did(i)
         if(ip.ne.0) prob(ip)=prob(ip)+prob(i)*0.5d0
         if(im.ne.0) prob(im)=prob(im)+prob(i)*0.5d0
      end if
   end do

  x=0.d0
  y=0.d0
  nfond=0
  do i=1,n
     if(sid(i).eq.0 .and. did(i).eq.0 .and. stat1(i).ne.1.and.prob(i).gt.0.d0) then
        nfond=nfond+1
        y=prob(i)/dfloat(npop)
        x=x+y*y
     else if((sid(i).eq.0 .or. did(i).eq.0) .and. stat1(i).ne.1 .and. prob(i).gt.0.d0) then
        y=prob(i)*0.5d0/dfloat(npop)
        x=x+y*y
        nfond=nfond+1
     end if
   end do
 
   x=1.d0/x
 ! print*,'372' 
!---------------------Pokus o f_ii------------------------
 nn=year(ha)
 allocate(iii(nn))

! allocate(iii(year(ha)))

! print*,'389',year(ha)
  mm=0

  do i=1,n
   if(stat1(i).EQ.1)then
     mm=mm+1
     iii(mm)=aid(i)
   end if
  end do
! print*,'395',mm
  mm=0
  fii=0

!print*,'389'
 !! do i=1,sub
! !  do j=1,sub
      do o=1,year(ha)
        do p=1,year(ha)
 !         k=o
          k=min(iii(o),iii(p))
          l=max(iii(o),iii(p))
          mm=row(k)+(l-k)
          fii=fii+A(mm)
        end do
      end do
     fii=fii/(2*year(ha)*year(ha))
!!  end do
!!end d
!print*,'412',ha
!print*,year(ha)
!print*,nfond
!print*,x
!print*,fii

! deallocate(iii)



write(5,'(i8,6x,f10.4,12x,f10.4,12x,f10.4)')ha, (1/(2*x)), fii-(1/(2*x)),fii
!  write(5,*)ha
! write(3,'(2i8,i7,f10.2)')xx,year(xx),nfond,x
!write(14,*)'Populace: ',breed(xx)


 deallocate(iii)
 
   


 fii=0
 do i=1,n
    if(rok(i).eq.ha .and. stat1(i).eq.1) then
      fii=fii+f(i)
    end if
 end do

 write(8,'(i5,f12.8,i5)')ha,fii/year(ha), year(ha)

 end do


end do


end subroutine p_org

end module porg
