module read

use glob_var

implicit none

contains

subroutine read_par

character(40)::xc,param
integer::i,m,n1,x,aid_pos,sid_pos,did_pos,gen_pos,yob_pos,breed_pos,sex_pos,stat_pos
integer::cteni(8)
!integer,allocatable::breed(:)

write(*,'(a)',advance='no')'Name of parametr file? '
read '(a)',param
param=adjustl(param)
write(*,'(a)') param

open(1,file=param)

call readline(1,xc,n1)
if(n1.eq.-1) then
        print*, 'IMPUT FILE EMPTY'
        stop
end if

print*,xc
if(xc.ne.'PEDFILE') then
  print*,'PEDFILE not found'
  stop
end if

call readline(1,xc,n1)
rod=xc
print*,rod

call readline(1,xc,n1)
if(xc.ne.'AID') then
  print*,'AID position not found'
  stop
end if

call readline(1,xc,n1)
print*,xc
read(xc,'(i5)')x
aid_pos=x

print*,'AID = ',aid_pos

call readline(1,xc,n1)
if(xc.ne.'SID') then
  print*,'SID position not found'
  stop
end if

call readline(1,xc,n1)
print*,xc
read(xc,'(i5)')x
sid_pos=x

print*,'SID = ',sid_pos

call readline(1,xc,n1)
if(xc.ne.'DID') then
  print*,'DID position not found'
  stop
end if

call readline(1,xc,n1)
print*,xc
read(xc,'(i5)')x
did_pos=x
print*,'DID = ',did_pos

call readline(1,xc,n1)
if(xc.ne.'GEN') then
  print*,'Generation position not found'
  stop
end if

call readline(1,xc,n1)
print*,xc
read(xc,'(i5)')x
gen_pos=x

print*,'GEN = ',gen_pos

call readline(1,xc,n1)
if(xc.ne.'YOB') then
  print*,'YOB position not found'
  stop
end if

call readline(1,xc,n1)
print*,xc
read(xc,'(i5)')x
yob_pos=x

print*,'YOB = ',yob_pos

call readline(1,xc,n1)
if(xc.ne.'BREED') then
  print*,'BREED position not found'
  stop
end if

call readline(1,xc,n1)
print*,xc
read(xc,'(i5)')x
breed_pos=x

print*,'BREED = ',breed_pos

call readline(1,xc,n1)
if(xc.ne.'SEX') then
  print*,'SEX position not found'
  stop
end if

call readline(1,xc,n1)
print*,xc
read(xc,'(i5)')x
sex_pos=x

print*,'SEX = ',sex_pos

call readline(1,xc,n1)
if(xc.ne.'STAT') then
  print*,'STAT position not found'
  stop
end if

call readline(1,xc,n1)
print*,xc
read(xc,'(i5)')x
stat_pos=x

print*,'STAT = ',stat_pos

!---------------------------------------------

call readline(1,xc,n1)
if(xc.ne.'N_AID') then
  print*,'N_AID not found'
  stop
end if

call readline(1,xc,n1)
print*,xc
read(xc,'(i5)')x
n=x

print*,'N_AID = ',n


call readline(1,xc,n1)
if(xc.ne.'N_ITER') then
  print*,'N_ITER not found'
  stop
end if

call readline(1,xc,n1)
print*,xc
read(xc,'(i5)')x
nit=x

print*,'N_ITER = ',nit

!call readline(1,xc,n1)
!if(xc.ne.'N_SUB') then
!  print*,'N_SUB not found'
!  stop
!end if

!call readline(1,xc,n1)
!print*,xc
!read(xc,'(i5)')x

sub=1

!print*,'N_sub = ',sub

allocate(breed(sub))

call readline(1,xc,n1)
if(xc.ne.'SUB_CODES') then
  print*,'SUB_CODES not found'
  stop
end if

do i=1,sub
 call readline(1,xc,n1)
 print*,xc
 read(xc,'(i5)')x
 breed(i)=x
end do

print*,'SUB_CODES = ',breed(:)


!--------Toto otevrit az po overeni...................
m=(n*(n-1)/2)+n
allocate(aid(n),sid(n),did(n),f(n),A(m),row(n),gen(n),plem(n),sex(n),rok(n),stat(n)) 
!,avginb(kk),avginbn(kk),navg(kk))

open(11,file=rod)
do i=1,n
 read(11,'(8I10)')cteni(:)
 aid(i)=cteni(aid_pos)
 sid(i)=cteni(sid_pos)
 did(i)=cteni(did_pos)
 gen(i)=cteni(gen_pos)
 rok(i)=cteni(yob_pos)
 plem(i)=cteni(breed_pos)
 sex(i)=cteni(sex_pos)
 stat(i)=cteni(stat_pos)
end do


!do i=1,10
!  print*,aid(i),sid(i),did(i),gen(i),rok(i),plem(i),sex(i),stat(i)
!end do

open(2,file='results.lst')
close(2)

end subroutine read_par


subroutine readline(unit,xc,n1,nohash)

   integer::unit,n1,stat,i
   integer,optional::nohash
   character(40)::xc,a

   do

    read(unit,'(a)',iostat=stat)a
    if (stat .ne. 0) then
            n1=-1
            return
    end if
    xc=adjustl(a)

    if(present(nohash)) then
            exit
    else
    i=scan(xc,'#')
      if(i .eq. 0) exit
      if(i .gt. 1) then
              xc=xc(1:i-1)
              exit
      end if
    endif
  end do

  end subroutine readline

 end module read 









!=============================================================
!read(1,'(a)',iostat=stat)xc
!  if (stat .ne. 0) then
!          print*, 'INPUT FILE EMPTY'
!          stop
!  end if


!call note(xc,i)

!print*,xc,'XXXXXX', i,a

!xc=xc(1:i-1)

!print*,xc

!read(1,'(a)')xc

!print*,xc

!read(xc(1:5),'(i5)')x

!print*,x*10


!CONTAINS

!subroutine note(xc,i,nohash)

! character(40)::a,xc
! integer::i
! integer,optional::nohash

! xc=adjustl(xc)

!do
!  i=scan(xc,'#')

!  if(i .eq. 0) then
!          exit
!  else

! if(present(nohash)) then
!    exit
!  else 
!    i=scan(a,'#')
!    exit
  !  if (i .eq. 0) exit
  !  if (i .lt. 1) then
  !      a=a(
!  end if
!end do 

!end subroutine

!end program
