module inbreed

use glob_var

implicit none

contains

subroutine inbreed_Tab(niter)

integer::i,j,jj,k,kk,l,niter,m,mm,time(3)!,xx,xxx,xx4,xx5,xx6,xx7,xx8
integer,allocatable::navg(:)
real::aip,aiq,t1,t2,minb,minbold
real,allocatable::avginb(:),avginbn(:)


kk=maxval(gen)


allocate(avginb(kk),avginbn(kk),navg(kk))

!-----------------------------------------
call itime(time)
write(*,*)'------------------------------------------'
write(*,*)'out file for results :./inbreeditng.txt'
write(*,*)'------------------------------------------'
write(*,'("Zacatek, time= ",i2.2,":",i2.2,":",i2.2)')time(1),time(2),time(3)
!-----------------------------------------------

avginbn=0

mm=0
do i=1,n
 m=(((i-1)*n)+i)-((i-1)+mm)
 row(i)=m
 mm=mm+i-1
end do



!==============Inbreedint=======================================
print*,'-----Inbreeding----------------'
do jj=1,niter
call cpu_time(t1)

 f=0; avginb=avginbn; avginbn=0; navg=0; A=0

 do i=1,n
   A(row(i))=1
 end do

 do i=1,n
    k=min(sid(i),did(i))
    l=max(sid(i),did(i))
    if(sid(i) .GT. 0 .AND. did(i) .GT. 0) then
       m=row(i)
       mm=row(k)+(l-k)
       A(m)=A(m)+0.5*A(mm)
       f(i)=0.5*A(mm)
       avginbn(gen(i))=avginbn(gen(i))+f(i)
       navg(gen(i))=navg(gen(i))+1;
    else
       m=row(i)
       A(m)=A(m)+avginb(abs(min(sid(i),did(i))))
       f(i)=avginb(abs(min(sid(i),did(i))))
    end if


   if(i.EQ.n)exit


   do j=i+1,n
     if(sid(j).LE.0) aip=2*(avginb(abs(sid(j))))
     if(sid(j).GT.0) then
        k=min(i,sid(j))
        l=max(i,sid(j))
        mm=row(k)+(l-k)
        aip=A(mm)
     end if

     if(did(j).LE.0) aiq=2*(avginb(abs(did(j))))
     if(did(j).GT.0) then
        k=min(i,did(j))
        l=max(i,did(j))
        mm=row(k)+(l-k)
        aiq=A(mm)
     end if

    mm=row(i)+(j-i)
    A(mm)=0.5*(aip+aiq)


   end do

 end do

call cpu_time(t2)


!----------------------------------------------------------
call itime(time)
write(*,*)'------------------------------------------'
write(*,'("iterace: ",I3,"   time1: ",i2.2,":",i2.2,":",i2.2)')jj,time(1),time(2),time(3)
!---------------------------------------------------------

minb=sum(f)/n
where(navg.ne.0)
  avginbn=avginbn/navg
end where
!----------------------------------------------------------
write(*,*)'conv:',abs(minbold-minb)
!---------------------------------------------------------
if(abs(minbold-minb).LT.1.e-6)exit
minbold=minb
end do


open(7,file='inbreeding.txt')
do i=1,n
 write(7,'(I6,4x,F10.7)')i,f(i)
end do


end subroutine inbreed_Tab

end module inbreed

