module ne_ng

use glob_var

implicit none

contains

subroutine neng
integer::i,j,ip,im,kk,num,xx,k,l,mm,numic1,numic2
integer,allocatable::ic1(:),ic2(:)!,numic1(:),numic2(:)
real::ne,avgdelf,delc,ne_c,csid,cdid
real,allocatable::res(:,:),mini(:),maxi(:),aver(:), &
                  eqgen(:),delf(:),pci(:,:),stat1(:)!, & !tab(:,:),&
                 !deltc(:)! ic1(:),ic2(:),numic1(:),numic2(:)



!----------------------------------
open(2,file='results.lst',status='old',position='append')
open(3,file='ngen.res')
!open(4,file='ne_rel.out')
!open(6,file='ngen.out')
!-----------------------------------

kk=50

allocate(tab(kk,n),stat1(n))
do xx=1,sub
! print*,'Populace: ',xx
 write(2,*)'Population: ',breed(xx)
 write(2,*)' '
 if(breed(xx).ne.0)then
    do i=1,n
       if(plem(i).eq.breed(xx) .and. stat(i).eq.1)then
          stat1(i)=1
       else
          stat1(i)=0
       end if
    end do
 else
     stat1=stat
 end if
 !----------------------------------

 !kk=50

 !allocate(tab(kk,n))

 tab=0.0

 print*,'sum(stat1)',sum(stat1)

 do i=1, n
    ip=sid(i)
    im=did(i)
 
    if(ip.GT.0) then
       call ngen(i,ip,kk)!,tab)
    end if
 
    if(im.GT.0) then
       call ngen(i,im,kk)!,tab)
    end if
 end do

!print*,'60'

 !------------------N-gen---------------------
 num=sum(stat1(:))
 allocate(res(kk,num),eqgen(num))

 !!open(6,file='ngen.out')
 !write(6,*)'---------------------------------------------'
 !write(6,*)'Plemeno ',xx
 !write(6,*)' '


 num=0
 do i=1,n
   if(stat1(i).eq.1) then
      num=num+1
      eqgen(num)=sum(tab(:,i))
 !     write(6,'(i5,f12.7,50f10.7)')i,eqgen(num),tab(:,i) !ZDE
      res(:,num)=tab(:,i)
   end if
 end do

!write(*,*)'77'

 !...Popisne statistiky........................
 allocate(mini(kk),maxi(kk),aver(kk))
 do i=1,kk
   mini(i)=minval(res(i,:))
   maxi(i)=maxval(res(i,:))
   aver(i)=sum(res(i,:))/num
 end do


 !...Ulozeni souboru pop. statistik..........

 !open(3,file='ngen.res')
 write(3,*)'---------------------------------------------'
 write(3,*)'Breed ',breed(xx)
 write(3,*)' '

!print*,'107'

 write(3,*)'eq.gen: min: ',minval(eqgen(:)),'mean: ',sum(eqgen(:))/num ,'max: &
 ',maxval(eqgen(:))
 write(3,*)'-------------------------------------------------------------------'
 write(3,*)' gen','       min','      mean','       max'

 do i=1,kk
!     print*,i,mini(i),aver(i),maxi(i)
     write(3,'(i5,3f10.7)')i,mini(i),aver(i),maxi(i)
 end do

close(3)

 !pokus o PCI
 !.........Pedigree completeness index..............
open(3,file='ngen.res',status='old',position='append')
 allocate(pci(kk,n))            ! otazka - je nutne ji zadat do promenych

 pci=0.0

 do j=1,kk
  do i=1, n
     csid=0.0
     cdid=0.0
 
     if(sid(i).GT.0) then
       do ip=1,j
          csid=csid+tab(ip,sid(i))
       end do
     end if
    csid=csid/j

    if(did(i).GT.0) then
       do im=1,j
           cdid=cdid+tab(im,did(i))
       end do
    end if 
    cdid=cdid/j
 
    if(csid .NE. 0.0 .AND. cdid .NE. 0.0) then
      pci(j,i)=(2*csid*cdid)/(csid+cdid)
    end if
 
  end do
 end do

 res=0.0
 num=0

 do i=1,n
  if(stat1(i).eq.1) then
      num=num+1
      res(:,num)=pci(:,i)
   end if
 end do

 print*,'160'
 !...Popisne statistiky 2........................ 
 mini=.0; maxi=.0;aver=.0
 do i=1,kk
  mini(i)=minval(res(i,:))
  maxi(i)=maxval(res(i,:))
  aver(i)=sum(res(i,:))/num
 end do
  
 print*,'173'
 !...Ulozeni souboru pop. statistik..........

 write(3,*)'-------------------------------------------'
 write(3,*)'|                PCI                      |'
 write(3,*)'-------------------------------------------'
 write(3,*)' gen','       min','      mean','       max'


print*,kk 
! do i=1,1
 do i=1,kk
!   print*,i,mini(i),aver(i),maxi(i)
   write(3,'(i5,3f10.7)')i,mini(i),aver(i),maxi(i)
 end do
 print*,'179'
! deallocate(mini,maxi,aver)

 print*,'num',num
 print*,'182'
 close(3)

 !-------------------------------------------
 !............Vypocet Ne_F + ulozeni...........
 
!  num=sum(stat1(:))
  print*,'num',num
 allocate(delf(num))

 num=0
! open(4,file='ne_rel.out')
! write(4,*)'   animal','      eq.gen','       delta F'
! write(4,*)'---------------------------------------------'

 print*,'196'

 do i=1,n
    if(stat1(i).eq.1) then
      num=num+1
      delf(num)=1.-((1.-f(i))**(1./(eqgen(num)-1.)))
!      write(4,'(i10,f12.7,f14.7)')i,eqgen(num),delf(num)
    end if
 end do

 ne=1./(2.*(sum(delf)/num))
 avgdelf=(sum(delf)/num)

 write(*,*)ne

 print*,'211'
!-------------------------------------------
!............Vypocet Ne_C + ulozeni...........       Dopsat deklarace!!!!!!!
 
 numic1=0
 numic2=0

 do i=1,n
    if(stat1(i).eq.1 .and. sex(i).eq.1) numic1=numic1+1
    if(stat1(i).eq.1 .and. sex(i).eq.2) numic2=numic2+1
 end do

! print*,'223'

 allocate(ic1(numic1),ic2(numic2))
 
! print*,'227'

 numic1=0
 numic2=0

 do i=1,n
    if(stat1(i).eq.1 .and. sex(i).eq.1) then
       numic1=numic1+1    
       ic1(numic1)=aid(i)   
    end if
    
    if(stat1(i).eq.1 .and. sex(i).eq.2) then
       numic2=numic2+1
       ic2(numic2)=aid(i)
   end if
 end do

!print*,'244'

 num=0
 delc=0
 do i=1,numic1
    do j=1,numic2
     num=num+1
     k=min(ic1(i),ic2(j))
     l=max(ic1(i),ic2(j))
     mm=row(k)+(l-k)
!     print*,delc,A(mm),sum(tab(:,k)),sum(tab(:,l))  !tady je to spatne
     delc=delc+(1.-((1.-(A(mm)/2.))**(1./((sum(tab(:,k))+sum(tab(:,l)))/2.))))
      end do
!    print*,'257'
 end do
 
!  print*,'258'

 ne_c=1./(2.*(delc/num))



 !deltc1=1-(cij/2); deltc2=deltc1**(1/t); deltc3=1-deltc2;run;


 ! print*,'267'

 !-------------------------------------------
 !...Ulozeni souboru vystupu................
 write(2,*)'------------------------------------------------------------'
 write(2,*)'Population',breed(xx)
 write(2,*)'Realized effective size base on average delta F= ',ne
 write(2,*)'Realized effective size base on average delta C= ',ne_c
 write(2,*)'Effective population size base on sex ration =  ',((4*numic1*numic2)/(numic1+numic2))
 write(2,*)'Average rate of inbreeding=                     ',avgdelf
 write(2,*)'Number of male =                                ',numic1
 write(2,*)'Number of famale =                              ',numic2
 write(2,*)'------------------------------------------------------------'

 deallocate(eqgen,delf,res)
end do

deallocate(tab)

end subroutine neng


!==========================================


subroutine ngen(i,ip,kk)!,tab)
integer::i,ip,j,k,kk1,kk
!real::tab(:,:)

kk1=kk-1
tab(1,i)=tab(1,i)+0.5

do j=1,kk1
  if(tab(j,ip) .eq. 0) return
  k=j+1
  tab(k,i)=tab(k,i)+tab(j,ip)*0.5
end do
end subroutine ngen



end module ne_ng
