module relat

use glob_var

implicit none

contains

subroutine rel


integer::i,j,k,l,m,mm,nn,o,xx
integer,allocatable::ii(:),jj(:),stat1(:)
real::summat,avg,sd,avgfx
real,allocatable::avmat(:)
!----------------------------------
open(2,file='results.lst',status='old',position='append')

allocate(stat1(n))
do xx=1,sub
! print*,'Populace: ',xx
 write(2,*)'--------------------'
 write(2,*)'Population: ',breed(xx)
 
 write(2,*)' '
 
 if(breed(xx).ne.0)then
    do i=1,n
       if(plem(i).eq.breed(xx) .and. stat(i).eq.1)then
          stat1(i)=1
       else
          stat1(i)=0
       end if
    end do
 else
     stat1=stat
 end if



!----------------------------------
 nn=sum(stat1)

 print*,'Sum Stat= ',nn
 
 allocate(ii(nn),jj(nn),avmat(nn))

 o=0

 do i=1,n
   if(stat1(i).eq.1)then
     o=o+1
     ii(o)=aid(i)
     jj(o)=aid(i)
   end if
 end do

 avmat=0

 do i=1,nn
   do j=1,nn
     k=min(ii(i),jj(j))
     l=max(ii(i),jj(j))
     mm=row(k)+(l-k)
     avmat(i)=avmat(i)+A(mm)
   end do
 end do

 summat=sum(avmat)

 do i=1,nn
   avmat(i)=avmat(i)/nn
 end do

 avg=sum(avmat)/nn
 sd=sqrt((dot_product(avmat,avmat)-(avg*sum(avmat)))/(nn-1))

 avgfx=0
 do i=1,n
   if(stat1(i).eq.1) then
     avgfx=avgfx+f(i)
    end if
 end do
 
 avgfx=avgfx/nn

 !open(4,file='prum_rel.lst')
 
 write(2,*)'summat= ',summat
 write(2,*)'avg. inbreeding = ',avgfx
 write(2,*)'avg. co-ancester= ',summat/(2*nn**2)
 write(2,*)'avg. rel. coeff.= ',avg
 write(2,*)'sd. rel.coeff.= ',sd
 write(2,*)'--------------------'

 close(2) 
 !do i=1,nn
 !   write(4,'(I6,4x,F10.7)')ii(i),avmat(i)
 !end do
 deallocate(ii,jj,avmat)
end do

end subroutine rel

end module relat

